﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ArmoredCar
{
    internal class DrawningObjectArmCar : IDrawningObject
    {
        private DrawningArmoredCar _armCar = null;
        public DrawningObjectArmCar(DrawningArmoredCar car)
        {
            _armCar = car;
        }
        public float Step => _armCar?.ArmoredCar?.Step ?? 0;
        public (float Left, float Right, float Top, float Bottom)
       GetCurrentPosition()
        {
            return _armCar?.GetCurrentPosition() ?? default;
        }
        public void MoveObject(Direction direction)
        {
            _armCar?.MoveTransport(direction);
        }
        public void SetObject(int x, int y, int width, int height)
        {
            _armCar.SetPosition(x, y, width, height);
        }
        void IDrawningObject.DrawningObject(Graphics g)
        {
            if (_armCar != null)
                _armCar.DrawTransport(g);
        }
        public string GetInfo() => _armCar?.GetDataForSave();
        public static IDrawningObject Create(string data) => new
       DrawningObjectArmCar(data.CreateDrawningArmoredCar());
    }
}
