﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ArmoredCar
{
    internal class DrawningTank : DrawningArmoredCar
    {
        /// <summary>
        /// Инициализация свойств
        /// </summary>
        /// <param name="speed">Скорость</param>
        /// <param name="weight">Вес бронированной машины</param>
        /// <param name="bodyColor">Цвет кузова</param>
        /// <param name="dopColor">Дополнительный цвет</param>
        /// <param name="towerWeapon">Признак наличия башни с орудием</param>
        /// <param name="aMachineGun">Признак наличия зенитного пулемета</param>
        public DrawningTank(int speed, float weight, Color bodyColor, Color
       dopColor, bool towerWeapon, bool aMachineGun) :
        base(speed, weight, bodyColor, 110, 60)
        {
            ArmoredCar = new EntityTank(speed, weight, bodyColor, dopColor, towerWeapon, aMachineGun);
        }
        public override void DrawTransport(Graphics g)
        {
            if (ArmoredCar is not EntityTank Tank)
            {
                return;
            }
            Brush dopBrush = new SolidBrush(Tank.DopColor);

            if (Tank.AMachineGun)
            {
                g.FillRectangle(dopBrush, _startPosX + 40, _startPosY, 5, 20);
                g.FillRectangle(dopBrush, _startPosX + 40, _startPosY, 40, 5);
                g.FillEllipse(dopBrush, _startPosX + 27, _startPosY + 7, 30, 10);
            }
            if (Tank.TowerWeapon)
            {
                g.FillRectangle(dopBrush, _startPosX + 60, _startPosY + 15, 7, 10);
                g.FillRectangle(dopBrush, _startPosX + 60, _startPosY + 17, 20, 5);
            }
            _startPosY += 10;
            base.DrawTransport(g);            
            _startPosY -= 10;            
        }
        public override void setColor(Color color)
        {
            ArmoredCar = new EntityTank(ArmoredCar.Speed, ArmoredCar.Weight, color,
                 (ArmoredCar as EntityTank).DopColor, (ArmoredCar as EntityTank).TowerWeapon, (ArmoredCar as EntityTank).AMachineGun);
        }
        public void setDopColor(Color color)
        {
            ArmoredCar = new EntityTank(ArmoredCar.Speed, ArmoredCar.Weight, ArmoredCar.BodyColor, 
                color, (ArmoredCar as EntityTank).TowerWeapon, (ArmoredCar as EntityTank).AMachineGun);
        }
    }
}
